#include <SD.h>
#include <RTClib.h>

#define SD_PIN 10
#define LED_PIN 9
#define SWITCH_PIN 3
#define SENSOR_PIN A1
#define FILE_NAME "datalog.csv"

File file;
RTC_DS3231 rtc;

void setup() {
  pinMode(SWITCH_PIN, INPUT);
  pinMode(LED_PIN, OUTPUT);
  
  while (!SD.begin(SD_PIN));
  
  rtc.begin();
  if (rtc.lostPower()) {
    rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
  }
}

void loop() {
  int enable = digitalRead(SWITCH_PIN);
  
  if (!enable) {
    return;
  }

  DateTime now = rtc.now();
  char dateBuffer[] = "DD/MM/YYYY hh:mm:ss";
  log(now.toString(dateBuffer), analogRead(SENSOR_PIN));
  delay(500);
}

void log(String data, int value) {
  file = SD.open(FILE_NAME, FILE_WRITE);
  if (!file) {
    if (SD.begin(SD_PIN)) {
      file = SD.open(FILE_NAME, FILE_WRITE);
    }
  }
  if (file) {
    digitalWrite(LED_PIN, HIGH);
    file.println(data + "," + String(value));
    file.close();
    digitalWrite(LED_PIN, LOW);
  }
}
